.386
.model flat,stdcall
option casemap:none

include filefunc.inc

; Exit codes returned by WriteFileToDisc

; INVALID_HANDLE_VALUE equ -1 ; CreateFile API error
  WRITEFILE_ERROR      equ 0  ; WriteFile API error
  WRITEFILEDISC_OK     equ 1  ; Operation successfull

PUBLIC  WriteFileToDisc@12

.code

;   WriteFileToDisc PROC pFileName:DWORD,pMemory:DWORD,nSize:DWORD

;       pFileName       :   pointer to file name
;       pMemory         :   address of data block to write to disc
;       nSize           :   number of bytes to write

WriteFileToDisc@12:

    sub     esp,2*4                     ; reserve 8 bytes for local variables
    
    invoke  CreateFile,DWORD PTR [esp+36],GENERIC_WRITE,0,0,\
            CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
    cmp     eax,INVALID_HANDLE_VALUE
    je      _exitB
    
    push    esi
    mov     DWORD PTR [esp+4],eax       ; save the handle to the file
    lea     edx,DWORD PTR [esp+8]       ; get the address of number of bytes written
    invoke  WriteFile,eax,DWORD PTR [esp+32],DWORD PTR [esp+32],edx,0
    mov     esi,eax
    test    eax,eax
    jz      _exitA
    
    mov     esi,WRITEFILEDISC_OK

_exitA:
   
    invoke  CloseHandle,DWORD PTR [esp+4]

    mov     eax,esi
    pop     esi

_exitB:

    add     esp,2*4                 ; balance the stack
    ret     3*4

;   ENDP WriteFileToDisc

END

